# Jarvis Web Gateway

![logo](https://www.nsquared.nz/img/nsquared-logo-big.png)

<p align="center">
  <strong>
    <a href="https://www.nsquared.nz/">website</a>
    •
    <a href="https://www.nsquared.nz/tech/jarvis.html">docs</a>
  </strong>
</p>


## Introduction

The Jarvis Web Gateway is a lightweight web-service designed to give Rich Internet Applications a rapid, powerful and secure mechanism to access and update server-side databases.  Jarvis can be configured to use Apache's “mod_perl” for better performance than simple CGI.
Jarvis supports fetch, create, update and delete with additional support for custom plug-in features.  Jarvis is based on the RESTful approach to http web services.  It provides JSON, XML interfaces, with additional support for CSV and MS Excel downloads.  
Jarvis works excellently with JavaScript web apps using Angular, ExtJS, Dojo and many other JS toolkits, and is also ideal for client applications such as those written in Adobe Flex.
Jarvis supports any database for which a Perl DBI driver exists.  This include Oracle, PostgreSQL, MySQL, SQL Server, SQLite and more.


## Installation

For a detailed guide in installing, configuring and testing Jarvis, please see the **[Installation Instructions](docs/jarvis_install.pdf)** documentation.


## License

Jarvis (including documentation) is free software: you can redistribute it and/or modify it under the terms of the **[GNU Lesser General Public License](LICENSE)** as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
Jarvis is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with Jarvis.  If not, see <http://www.gnu.org/licenses/>.

This software (including documentation) is Copyright 2018 N-Squared Software (NZ) Ltd.
